# std::unordered_set<Key,Hash,KeyEqual,Allocator>::merge

From cppreference.com
< cpp‎ | container‎ | unordered set

template<class H2, class P2> void merge( std::unordered_set <Key, H2, P2, Allocator>& source); | (1) | (since C++17)
template<class H2, class P2> void merge( std::unordered_set <Key, H2, P2, Allocator>&& source); | (2) | (since C++17)
template<class H2, class P2> void merge( std::unordered_multiset <Key, H2, P2, Allocator>& source); | (3) | (since C++17)
template<class H2, class P2> void merge( std::unordered_multiset <Key, H2, P2, Allocator>&& source); | (4) | (since C++17)

Attempts to extract ("splice") each element in `source` and insert it into `*this` using the hash function and key equality predicate of `*this`. If there is an element in `*this` with key equivalent to the key of an element from `source`, then that element is not extracted from `source`. No elements are copied or moved, only the internal pointers of the container nodes are repointed. All pointers and references to the transferred elements remain valid, but now refer into `*this`, not into `source`. Iterators referring to the transferred elements and all iterators referring to `*this` are invalidated. Iterators to elements remaining in `source` remain valid.

The behavior is undefined if get_allocator() != source.get_allocator().

### Parameters

source | - | compatible container to transfer the nodes from

### Return value

(none)

### Complexity

Average case O(N), worst case O(N*size()+N), where N is `source.size()`

### Example

| This section is incomplete Reason: no example

### See also

extract (C++17) | extracts nodes from the container (public member function)
insert | inserts elements or nodes (since C++17) (public member function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/container/unordered_set/merge&oldid=104961"